import React, { MutableRefObject } from 'react';
import { BaseEditor } from 'slate';
import { ReactEditor } from 'slate-react';
export interface SmartInputProps {
    value: string;
    onChange: (newValue: string) => void;
    renderText: (props: any) => React.ReactElement;
    renderCompletion: (props: any) => React.ReactElement;
    renderPlaceholder?: (props: any) => React.ReactElement;
    modelId?: string;
    context?: any;
    editorRef?: MutableRefObject<any>;
    multiline?: boolean;
    onBlur?: React.FocusEventHandler<HTMLDivElement>;
    onFocus?: React.FocusEventHandler<HTMLDivElement>;
    onKeyDown?: React.KeyboardEventHandler<HTMLDivElement>;
    placeholder?: string;
    style?: React.CSSProperties;
    className?: string;
    mockCompletion?: (text: string) => string;
}
export declare function SmartInputDev(props: SmartInputProps): JSX.Element;
type CustomElement = {
    type: 'text' | 'completion' | undefined;
    children: CustomText[];
};
type CustomText = {
    text: string;
    type: undefined;
};
type CustomDescendant = CustomElement | CustomText;
type CEditor = Omit<BaseEditor, 'children'> & ReactEditor & {
    children: CustomDescendant[];
};
declare module 'slate' {
    interface CustomTypes {
        Editor: CEditor;
        Element: CustomElement;
        Text: CustomText;
    }
}
export {};
