/// <reference types="lodash" />
import { ICompletionResponse } from './ICompletionResponse';
export declare class SmartInputFetcher {
    addCompletion: (text: string, completion: ICompletionResponse) => void;
    modelId?: string | undefined;
    mockCompletion?: ((text: string) => string | null) | undefined;
    sequenceId: number;
    sessionId: string;
    fetchCache: Record<string, ICompletionResponse | null>;
    alreadySeen: Set<string>;
    alreadyAccepted: Set<string>;
    currentCompletion: {
        sequenceId: number;
        text: string;
        completion?: string | null;
    } | null;
    constructor(addCompletion: (text: string, completion: ICompletionResponse) => void, modelId?: string | undefined, mockCompletion?: ((text: string) => string | null) | undefined);
    fetchCompletion: import("lodash").DebouncedFunc<(text: string, context: any) => Promise<ICompletionResponse | null>>;
    updateCompletion(completionSid: string, arg: {
        seen?: boolean;
        accepted?: boolean;
    }): void;
    sendEvents: import("lodash").DebouncedFunc<(text: string, context: any) => void>;
}
