var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import debounce from 'lodash.debounce';
import throttle from 'lodash.throttle';
import { ulid } from 'ulid';
var SmartInputFetcher = (function () {
    function SmartInputFetcher(addCompletion, modelId, mockCompletion) {
        var _this = this;
        this.addCompletion = addCompletion;
        this.modelId = modelId;
        this.mockCompletion = mockCompletion;
        this.sequenceId = 0;
        this.sessionId = ulid();
        this.fetchCache = {};
        this.alreadySeen = new Set();
        this.alreadyAccepted = new Set();
        this.currentCompletion = null;
        this.fetchCompletion = debounce(function (text, context) { return __awaiter(_this, void 0, void 0, function () {
            var seqId, currExpectedText, cachedVal, completion_1, res, data;
            var _this = this;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (text.length === 0) {
                            return [2, null];
                        }
                        seqId = ++this.sequenceId;
                        if ((_a = this.currentCompletion) === null || _a === void 0 ? void 0 : _a.completion) {
                            currExpectedText = this.currentCompletion.text + this.currentCompletion.completion;
                            if (currExpectedText.startsWith(text)) {
                                return [2, null];
                            }
                        }
                        this.currentCompletion = { text: text, sequenceId: seqId };
                        cachedVal = this.fetchCache[text];
                        if (cachedVal) {
                            this.addCompletion(text, cachedVal);
                            this.currentCompletion.completion = cachedVal.completion;
                            return [2, cachedVal];
                        }
                        if (!this.mockCompletion) return [3, 3];
                        completion_1 = this.mockCompletion(text);
                        if (!completion_1) return [3, 2];
                        return [4, new Promise(function (resolve) {
                                setTimeout(function () {
                                    var _a;
                                    var c = { input: text, sid: ulid(), completion: completion_1 };
                                    _this.fetchCache[text] = c;
                                    if (((_a = _this.currentCompletion) === null || _a === void 0 ? void 0 : _a.sequenceId) === seqId) {
                                        _this.addCompletion(text, c);
                                        _this.currentCompletion.completion = completion_1;
                                    }
                                    resolve(c);
                                }, getRandomInt(200, 1000));
                            })];
                    case 1: return [2, _c.sent()];
                    case 2: return [2, { input: text, sid: ulid(), completion: null }];
                    case 3: return [4, fetch('https://api.foundation-ui.com/completions', {
                            method: 'POST',
                            mode: 'cors',
                            headers: {
                                'Content-Type': 'application/json',
                                Authorization: "Bearer ".concat(this.modelId),
                            },
                            body: JSON.stringify({
                                model: this.modelId,
                                input: text,
                                session: this.sessionId,
                                context: context,
                            }),
                        })];
                    case 4:
                        res = _c.sent();
                        if (res.status !== 200) {
                            console.error("Couldn't fetch completions");
                            return [2, null];
                        }
                        return [4, res.json()];
                    case 5:
                        data = (_c.sent());
                        this.fetchCache[text] = data;
                        if (((_b = this.currentCompletion) === null || _b === void 0 ? void 0 : _b.sequenceId) === seqId) {
                            this.addCompletion(text, data);
                            this.currentCompletion.completion = data.completion;
                        }
                        return [2, data];
                }
            });
        }); }, 200);
        this.sendEvents = throttle(function (text, context) {
            fetch('https://api.foundation-ui.com/events', {
                method: 'POST',
                mode: 'cors',
                headers: {
                    'Content-Type': 'application/json',
                    Authorization: "Bearer ".concat(_this.modelId),
                },
                body: JSON.stringify({
                    model: _this.modelId,
                    session: _this.sessionId,
                    input: text,
                    context: context,
                }),
            })
                .then(function (res) {
                if (res.status !== 200) {
                    console.error('Error sending events');
                }
            })
                .catch(function (e) { return console.error(e); });
        }, 1000, { trailing: true });
    }
    SmartInputFetcher.prototype.updateCompletion = function (completionSid, arg) {
        var _this = this;
        if (this.mockCompletion) {
            return;
        }
        var shouldUpdate = (arg.seen && !this.alreadySeen.has(completionSid)) || (arg.accepted && !this.alreadyAccepted.has(completionSid));
        if (!shouldUpdate) {
            return;
        }
        fetch('https://api.foundation-ui.com/completions', {
            method: 'PUT',
            mode: 'cors',
            headers: {
                'Content-Type': 'application/json',
                Authorization: "Bearer ".concat(this.modelId),
            },
            body: JSON.stringify({
                completionSid: completionSid,
                seen: arg.seen,
                accepted: arg.accepted,
            }),
        })
            .then(function (res) {
            if (res.status !== 200) {
                console.error("Couldn't update completion");
            }
            if (arg.seen) {
                _this.alreadySeen.add(completionSid);
            }
            if (arg.accepted) {
                _this.alreadyAccepted.add(completionSid);
            }
        })
            .catch(function (e) { return console.error(e); });
    };
    return SmartInputFetcher;
}());
export { SmartInputFetcher };
function getRandomInt(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min + 1)) + min;
}
//# sourceMappingURL=SmartInputFetcher.js.map